To add conditional formatting in SpreadJS, first use the conditionalFormats method to get the conditional format for the sheet. Then you can create a conditional rule and use the addRule method to add it. Also you can use the specified rule's add method, like addSpecificTextRule, addCellValueRule, and so on. For example:
After you add rules to the sheet, you can use the getRule method to return the rule using the rule index or get all the conditional rules. For example:
If you want to remove the conditional rule, use the removeRule, removeRuleByRange, or clearRule methods. For example:
var spreadNS = GC.Spread.Sheets;
window.onload = function () {
var spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"), { sheetCount: 2 });
initSpread(spread);
};
function initSpread(spread) {
var sheet = spread.getSheet(0);
sheet.suspendPaint();
var cfs = sheet.conditionalFormats ;
// sample title
sheet.addSpan(1, 1, 1, 7);
sheet.setValue(1, 1, "Conditional Format Samples");
sheet.getCell(1, 1).font("24px sans-serif");
sheet.getCell(1, 1).hAlign(spreadNS.HorizontalAlign.center);
sheet.setRowHeight(1, 35);
// cell value rule
var r = 2;
var c = 1;
var w = 3;
var h = 4;
sheet.addSpan(r, c, 1, w);
sheet.setValue(r, c, "Displays green background: value > 50:");
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
var increase = 0;
for (var row = 0; row < h - 1; row++) {
for (var col = 0; col < w; col++) {
sheet.setValue(row + 3, col + 1, increase);
increase += 10;
}
}
sheet.getRange(r, c, h, w).setBorder(new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed), {all: true});
var style = new spreadNS.Style();
style.backColor = "#CCFFCC";
cfs.addCellValueRule(spreadNS.ConditionalFormatting.ComparisonOperators.greaterThan, 50, 0, style, [new spreadNS.Range(r + 1, c, h - 1, w)]);
r = 2;
c = 5;
sheet.addSpan(r, c, 1, w);
sheet.setValue(r, c, "Displays red background: value >= 60 and value <= 70:");
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
increase = 0;
for (var row = 0; row < h - 1; row++) {
for (var col = 0; col < w; col++) {
sheet.setValue(row + r + 1, col + c, increase);
increase += 10;
}
}
sheet.getRange(r, c, h, w).setBorder(new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed), {all: true});
style = new spreadNS.Style();
style.backColor = "#FFCCCC";
cfs.addCellValueRule(spreadNS.ConditionalFormatting.ComparisonOperators.between, 60, 70, style, [ new spreadNS.Range(r + 1, c, h - 1, w) ]);
// 2 color scale rule
r = 7;
c = 1;
sheet.addSpan(r, c, 1, w);
sheet.setValue(r, c, "Displays two color gradient represents cell value:");
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
increase = 0;
for (var row = 0; row < h - 1; row++) {
for (var col = 0; col < w; col++) {
sheet.setValue(row + r + 1, col + c, increase);
increase += 10;
}
}
sheet.getRange(r, c, h, w).setBorder(new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed), {all: true});
cfs.add2ScaleRule(spreadNS.ConditionalFormatting.ScaleValueType.lowestValue, null, "#FF9999", spreadNS.ConditionalFormatting.ScaleValueType.highestValue, null, "#9999FF", [ new spreadNS.Range(r + 1, c, h - 1, w) ]);
// 3 color scale rule
r = 7;
c = 5;
sheet.addSpan(r, c, 1, w);
sheet.setValue(r, c, "Displays three color gradient represents cell value:");
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
increase = 0;
for (var row = 0; row < h - 1; row++) {
for (var col = 0; col < w; col++) {
sheet.setValue(row + r + 1, col + c, increase);
increase += 10;
}
}
sheet.getRange(r, c, h, w).setBorder(new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed), {all: true});
cfs.add3ScaleRule(spreadNS.ConditionalFormatting.ScaleValueType.lowestValue, null, "#FF9999",
spreadNS.ConditionalFormatting.ScaleValueType.number, 100, "#99FF99",
spreadNS.ConditionalFormatting.ScaleValueType.highestValue, null, "#9999FF", [new spreadNS.Range(r + 1, c, h - 1, w) ]);
// date occurring rule
addDays = function (date, days) {
var dt = new Date(date.getFullYear(), date.getMonth(), date.getDate() + days);
if (days) {
if (dt.getDate() === date.getDate()) {
dt = new Date(date.getFullYear(), date.getMonth(), date.getDate());
dt.setTime(dt.getTime() + (days * 24 * 3600 * 1000));
}
}
return dt;
};
r = 12;
c = 1;
sheet.addSpan(r, c, 1, w);
sheet.setValue(r, c, "Display blue background if cell value is in next week:");
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
increase = 0;
for (var row = 0; row < h - 1; row++) {
for (var col = 0; col < w; col++) {
sheet.setValue(row + r + 1, col + c, addDays(new Date(), increase));
sheet.setFormatter(row + r + 1, col + c, "yyyy/mm/dd", spreadNS.SheetArea.viewport);
increase += 1;
}
}
sheet.getRange(r, c, h, w).setBorder(new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed), {all: true});
style = new spreadNS.Style();
style.backColor = "#CCCCFF";
cfs.addDateOccurringRule(spreadNS.ConditionalFormatting.DateOccurringType.nextWeek, style, [ new spreadNS.Range(r + 1, c, h - 1, w) ]);
// specific text rule
r = 12;
c = 5;
sheet.addSpan(r, c, 1, w);
sheet.setValue(r, c, "Display red foreground if cell value contains \"o\":");
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
var data = ["The", "quick", "brown", "fox", "jumps", "over", "the", "lazy", "dog", "The", "quick", "brown", "fox", "jumps", "over", "the", "lazy", "dog"];
increase = 0;
for (var row = 0; row < h - 1; row++) {
for (var col = 0; col < w; col++) {
sheet.setValue(row + r + 1, col + c, data[increase]);
increase += 1;
}
}
sheet.getRange(r, c, h, w).setBorder(new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed), {all: true});
var style = new spreadNS.Style();
style.foreColor = "Red";
style.font = "bold 12px sans-serif";
cfs.addSpecificTextRule(spreadNS.ConditionalFormatting.TextComparisonOperators.contains, "o", style, [ new spreadNS.Range(r + 1, c, h - 1, w) ]);
// data bar rule
r = 17;
c = 1;
sheet.addSpan(r, c, 1, w);
sheet.setValue(r, c, "Display a colored data bar represents cell value:");
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
increase = 0;
for (var row = 0; row < h - 1; row++) {
for (var col = 0; col < w; col++) {
sheet.setValue(row + r + 1, col + c, increase);
increase += 10;
}
}
sheet.getRange(r, c, h, w).setBorder(new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed), { all: true });
var dataBarRule = cfs.addDataBarRule(spreadNS.ConditionalFormatting.ScaleValueType.lowestValue, null,
spreadNS.ConditionalFormatting.ScaleValueType.highestValue, null,
"green", [new spreadNS.Range(r + 1, c, h - 1, w)]);
dataBarRule.gradient(true);
dataBarRule.showBorder(false);
dataBarRule.showBarOnly(false);
// icon set rule
r = 17;
c = 5;
sheet.addSpan(r, c, 1, w);
sheet.setValue(r, c, "Displays an icon represents cell value:");
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
increase = 0;
for (var row = 0; row < h - 1; row++) {
for (var col = 0; col < w; col++) {
sheet.setValue(row + r + 1, col + c, increase);
increase += 10;
}
}
sheet.getRange(r, c, h, w).setBorder(new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed), { all: true });
var iconSetRule = cfs.addIconSetRule(spreadNS.ConditionalFormatting.IconSetType.fiveArrowsColored, [new spreadNS.Range(r + 1, c, h - 1, w)]);
iconSetRule.iconSetType();
iconSetRule.reverseIconOrder(false);
iconSetRule.showIconOnly(false);
sheet.resumePaint();
updateRuleCount();
document.getElementById("removeRule").addEventListener('click',function() {
var sels = sheet.getSelections();
if (sels && sels.length > 0) {
var sel = sels[0];
cfs.removeRuleByRange(sel.row, sel.col, sel.rowCount, sel.colCount);
updateRuleCount();
}
});
document.getElementById("clearRule").addEventListener('click',function() {
cfs.clearRule();
updateRuleCount();
});
function updateRuleCount() {
document.getElementById("ruleCount").innerHTML="Rule Count: " + cfs.count();
}
};
function getActualRange(range, maxRowCount, maxColCount) {
var row = range.row < 0 ? 0 : range.row;
var col = range.col < 0 ? 0 : range.col;
var rowCount = range.rowCount < 0 ? maxRowCount : range.rowCount;
var colCount = range.colCount < 0 ? maxColCount : range.colCount;
return new spreadNS.Range(row, col, rowCount, colCount);
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@grapecity/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/purejs/node_modules/@grapecity/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script>
<script src="app.js" type="text/javascript"></script>
<link rel="stylesheet" type="text/css" href="styles.css">
</head>
<body>
<div class="sample-tutorial">
<div id="ss" class="sample-spreadsheets"></div>
<div class="options-container">
<p>Select cell(s) that contains rule(s):</p>
<div class="option-row">
<label id="ruleCount"></label>
</div>
<div class="option-row">
<input type="button" id="removeRule" value="Remove the selection's rule" />
<input type="button" id="clearRule" value="Remove all the rules">
</div>
</div>
</div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
overflow: auto;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
}
.option-row {
padding-top: 6px;
}
input {
padding: 4px 8px;
margin-bottom: 6px;
box-sizing: border-box;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}

To add conditional formatting in SpreadJS, first use the conditionalFormats method to get the conditional format for the sheet. Then you can create a conditional rule and use the addRule method to add it. Also you can use the specified rule's add method, like addSpecificTextRule, addCellValueRule, and so on. For example:
After you add rules to the sheet, you can use the getRule method to return the rule using the rule index or get all the conditional rules. For example:
If you want to remove the conditional rule, use the removeRule, removeRuleByRange, or clearRule methods. For example:
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import './styles.css';
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
spread: GC.Spread.Sheets.Workbook;
hostStyle = {
width: 'calc(100% - 280px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
ruleCountDescription = "";
constructor() {
}
initSpread($event: any) {
this.spread = $event.spread;
let spread = this.spread;
let spreadNS = GC.Spread.Sheets;
let sheet = spread.getSheet(0);
sheet.suspendPaint();
let cfs = sheet.conditionalFormats;
// sample title
sheet.addSpan(1, 1, 1, 7);
sheet.setValue(1, 1, "Conditional Format Samples");
sheet.getCell(1, 1).font("24px sans-serif");
sheet.getCell(1, 1).hAlign(spreadNS.HorizontalAlign.center);
sheet.setRowHeight(1, 35);
// cell value rule
let r = 2;
let c = 1;
let w = 3;
let h = 4;
sheet.addSpan(r, c, 1, w);
sheet.setValue(r, c, "Displays green background: value > 50:");
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
let increase = 0;
for (let row = 0; row < h - 1; row++) {
for (let col = 0; col < w; col++) {
sheet.setValue(row + 3, col + 1, increase);
increase += 10;
}
}
sheet.getRange(r, c, h, w).setBorder(new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed), { all: true });
let style = new spreadNS.Style();
style.backColor = "#CCFFCC";
cfs.addCellValueRule(spreadNS.ConditionalFormatting.ComparisonOperators.greaterThan, 50, 0, style, [new spreadNS.Range(r + 1, c, h - 1, w)]);
r = 2;
c = 5;
sheet.addSpan(r, c, 1, w);
sheet.setValue(r, c, "Displays red background: value >= 60 and value <= 70:");
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
increase = 0;
for (let row = 0; row < h - 1; row++) {
for (let col = 0; col < w; col++) {
sheet.setValue(row + r + 1, col + c, increase);
increase += 10;
}
}
sheet.getRange(r, c, h, w).setBorder(new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed), { all: true });
style = new spreadNS.Style();
style.backColor = "#FFCCCC";
cfs.addCellValueRule(spreadNS.ConditionalFormatting.ComparisonOperators.between, 60, 70, style, [new spreadNS.Range(r + 1, c, h - 1, w)]);
// 2 color scale rule
r = 7;
c = 1;
sheet.addSpan(r, c, 1, w);
sheet.setValue(r, c, "Displays two color gradient represents cell value:");
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
increase = 0;
for (let row = 0; row < h - 1; row++) {
for (let col = 0; col < w; col++) {
sheet.setValue(row + r + 1, col + c, increase);
increase += 10;
}
}
sheet.getRange(r, c, h, w).setBorder(new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed), { all: true });
cfs.add2ScaleRule(spreadNS.ConditionalFormatting.ScaleValueType.lowestValue, null, "#FF9999", spreadNS.ConditionalFormatting.ScaleValueType.highestValue, null, "#9999FF", [new spreadNS.Range(r + 1, c, h - 1, w)]);
// 3 color scale rule
r = 7;
c = 5;
sheet.addSpan(r, c, 1, w);
sheet.setValue(r, c, "Displays three color gradient represents cell value:");
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
increase = 0;
for (let row = 0; row < h - 1; row++) {
for (let col = 0; col < w; col++) {
sheet.setValue(row + r + 1, col + c, increase);
increase += 10;
}
}
sheet.getRange(r, c, h, w).setBorder(new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed), { all: true });
cfs.add3ScaleRule(spreadNS.ConditionalFormatting.ScaleValueType.lowestValue, null, "#FF9999",
spreadNS.ConditionalFormatting.ScaleValueType.number, 100, "#99FF99",
spreadNS.ConditionalFormatting.ScaleValueType.highestValue, null, "#9999FF", [new spreadNS.Range(r + 1, c, h - 1, w)]);
r = 12;
c = 1;
sheet.addSpan(r, c, 1, w);
sheet.setValue(r, c, "Display blue background if cell value is in next week:");
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
increase = 0;
for (let row = 0; row < h - 1; row++) {
for (let col = 0; col < w; col++) {
sheet.setValue(row + r + 1, col + c, this.addDays(new Date(), increase));
sheet.setFormatter(row + r + 1, col + c, "yyyy/mm/dd", spreadNS.SheetArea.viewport);
increase += 1;
}
}
sheet.getRange(r, c, h, w).setBorder(new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed), { all: true });
style = new spreadNS.Style();
style.backColor = "#CCCCFF";
cfs.addDateOccurringRule(spreadNS.ConditionalFormatting.DateOccurringType.nextWeek, style, [new spreadNS.Range(r + 1, c, h - 1, w)]);
// specific text rule
r = 12;
c = 5;
sheet.addSpan(r, c, 1, w);
sheet.setValue(r, c, "Display red foreground if cell value contains \"o\":");
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
let data = ["The", "quick", "brown", "fox", "jumps", "over", "the", "lazy", "dog", "The", "quick", "brown", "fox", "jumps", "over", "the", "lazy", "dog"];
increase = 0;
for (let row = 0; row < h - 1; row++) {
for (let col = 0; col < w; col++) {
sheet.setValue(row + r + 1, col + c, data[increase]);
increase += 1;
}
}
sheet.getRange(r, c, h, w).setBorder(new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed), { all: true });
style = new spreadNS.Style();
style.foreColor = "Red";
style.font = "bold 12px sans-serif";
cfs.addSpecificTextRule(spreadNS.ConditionalFormatting.TextComparisonOperators.contains, "o", style, [new spreadNS.Range(r + 1, c, h - 1, w)]);
// data bar rule
r = 17;
c = 1;
sheet.addSpan(r, c, 1, w);
sheet.setValue(r, c, "Display a colored data bar represents cell value:");
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
increase = 0;
for (let row = 0; row < h - 1; row++) {
for (let col = 0; col < w; col++) {
sheet.setValue(row + r + 1, col + c, increase);
increase += 10;
}
}
sheet.getRange(r, c, h, w).setBorder(new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed), { all: true });
let dataBarRule = cfs.addDataBarRule(spreadNS.ConditionalFormatting.ScaleValueType.lowestValue, null,
spreadNS.ConditionalFormatting.ScaleValueType.highestValue, null,
"green", [new spreadNS.Range(r + 1, c, h - 1, w)]);
dataBarRule.gradient(true);
dataBarRule.showBorder(false);
dataBarRule.showBarOnly(false);
// icon set rule
r = 17;
c = 5;
sheet.addSpan(r, c, 1, w);
sheet.setValue(r, c, "Displays an icon represents cell value:");
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
increase = 0;
for (let row = 0; row < h - 1; row++) {
for (let col = 0; col < w; col++) {
sheet.setValue(row + r + 1, col + c, increase);
increase += 10;
}
}
sheet.getRange(r, c, h, w).setBorder(new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed), { all: true });
let iconSetRule = cfs.addIconSetRule(spreadNS.ConditionalFormatting.IconSetType.fiveArrowsColored, [new spreadNS.Range(r + 1, c, h - 1, w)]);
iconSetRule.iconSetType();
iconSetRule.reverseIconOrder(false);
iconSetRule.showIconOnly(false);
// sparkline rule
r = 22, c = 1;
sheet.addSpan(r, c, 1, 3);
sheet.setValue(r, c, 'Sales Team KPI - Actual vs Target (Bullet Sparkline):');
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
r = 23;
var bulletHeaders = ['Employee', 'Score', 'Performance'];
for (c = 1; c < 4; c++) {
sheet.setValue(r, c, bulletHeaders[c]);
}
var employees = ['Alice', 'Bob', 'Carol', 'David', 'Eva'];
var scores = [88, 72, 95, 58, 81];
for (let i = 0; i < 5; i++) {
sheet.setValue(r + 1 + i, 1, employees[i]);
sheet.setValue(r + 1 + i, 2, scores[i]);
sheet.setValue(r + 1 + i, 3, scores[i]);
sheet.setRowHeight(r + 1 + i, 28);
}
sheet.getRange(r - 1, 1, 7, 3).setBorder(new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed), { all: true });
var rule = cfs.addSparklineRule('BULLETSPARKLINE', {
measure: '@', target: 75, maxi: 100, good: 85, bad: 60, forecast: 80, colorScheme: '#4472C4'
}, [new spreadNS.Range(r + 1, 3, 5, 1)]);
if (rule) rule.showSparklineOnly(true);
r = 22; c = 5;
sheet.addSpan(r, c, 1, 5);
sheet.setValue(r, c, 'Budget Plan vs Actual (Lollipop Variance Sparkline):');
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
r = 23;
var lolHeaders = ['Department', 'Planned', 'Actual', 'Index', 'Variance'];
sheet.setColumnWidth(9, 160);
for (let i = 0; i < 5; i++) {
sheet.setValue(r, c + i, lolHeaders[i]);
}
var depts = ['R&D', 'Marketing', 'Sales', 'Support', 'HR'];
var planned = [500, 300, 400, 200, 150];
let actual = [380, 350, 360, 220, 120];
for (let i = 0; i < 5; i++) {
sheet.setValue(r + 1 + i, c, depts[i]);
sheet.setValue(r + 1 + i, c + 1, planned[i]);
sheet.setValue(r + 1 + i, c + 2, actual[i]);
sheet.setValue(r + 1 + i, c + 3, i + 1);
sheet.setRowHeight(r + 1 + i, 28);
}
sheet.getRange(r - 1, c, 7, 5).setBorder(new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed), { all: true });
// Helper: convert column index to letter (0=A, 1=B, ...)
function colToLetter(col) {
var s = '';
col++;
while (col > 0) {
col--;
s = String.fromCharCode(65 + (col % 26)) + s;
col = Math.floor(col / 26);
}
return s;
}
// Helper: build absolute range string like "$F$5:$K$5"
function absRange(row, col, rowCount, colCount) {
var r1 = row + 1, r2 = row + rowCount;
var c1 = colToLetter(col), c2 = colToLetter(col + colCount - 1);
return '$' + c1 + '$' + r1 + ':$' + c2 + '$' + r2;
}
var plannedRef = absRange(r + 1, c + 1, 5, 1);
var actualRef = absRange(r + 1, c + 2, 5, 1);
var rule = cfs.addSparklineRule('LOLLIPOPVARISPARKLINE', {
plannedValue: plannedRef,
actualValue: actualRef,
index: '@',
reference: 0,
mini: -0.5,
maxi: 0.5,
tickUnit: 0.1,
legend: true,
colorPositive: '#70AD47',
colorNegative: '#ED7D31',
lollipopHeaderColor: '#4472C4'
}, [new spreadNS.Range(r + 1, c + 4, 5, 1)]);
if (rule) rule.showSparklineOnly(true);
sheet.resumePaint();
this.updateRuleCount();
}
// date occurring rule
addDays(date: Date, days: number) {
let dt = new Date(date.getFullYear(), date.getMonth(), date.getDate() + days);
if (days) {
if (dt.getDate() === date.getDate()) {
dt = new Date(date.getFullYear(), date.getMonth(), date.getDate());
dt.setTime(dt.getTime() + (days * 24 * 3600 * 1000));
}
}
return dt;
}
removeRule() {
let sheet = this.spread.getSheet(0);
let cfs = sheet.conditionalFormats;
let sels = sheet.getSelections();
if (sels && sels.length > 0) {
let sel = sels[0];
cfs.removeRuleByRange(sel.row, sel.col, sel.rowCount, sel.colCount);
this.updateRuleCount();
}
}
clearRule() {
let sheet = this.spread.getSheet(0);
let cfs = sheet.conditionalFormats;
cfs.clearRule();
this.updateRuleCount();
}
updateRuleCount() {
let sheet = this.spread.getSheet(0);
let cfs = sheet.conditionalFormats;
this.ruleCountDescription = "Rule Count: " + cfs.count();
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<p>Select cell(s) that contains rule(s):</p>
<div class="option-row">
<input id="ruleCount" style="border: none;" [value]="ruleCountDescription" />
</div>
<div class="option-row">
<input type="button" id="removeRule" value="Remove the selection's rule" (click)="removeRule($event)" />
<input type="button" id="clearRule" value="Remove all the rules" (click)="clearRule($event)">
</div>
</div>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
overflow: auto;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
}
.option-row {
padding-top: 6px;
}
input {
padding: 4px 8px;
margin-bottom: 6px;
box-sizing: border-box;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.1.2-master-2026-06-10-2131/'
},
// map tells the System loader where to look for things
map: {
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-angular': 'cdn:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);

To add conditional formatting in SpreadJS, first use the conditionalFormats method to get the conditional format for the sheet. Then you can create a conditional rule and use the addRule method to add it. Also you can use the specified rule's add method, like addSpecificTextRule, addCellValueRule, and so on. For example:
After you add rules to the sheet, you can use the getRule method to return the rule using the rule index or get all the conditional rules. For example:
If you want to remove the conditional rule, use the removeRule, removeRuleByRange, or clearRule methods. For example:
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import './styles.css';
import { AppFunc } from './app-func';
import { App } from './app-class';
// 1. Functional Component sample
createRoot(document.getElementById('app')).render(<AppFunc />);
// 2. Class Component sample
// createRoot(document.getElementById('app')).render(<App />);
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import GC from '@mescius/spread-sheets';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import './styles.css';
const Component = React.Component;
function _getElementById(id) {
return document.getElementById(id);
}
export function AppFunc() {
const [spread,setSpread] = React.useState(null);
const [state,setState] = React.useState({ ruleCountDescription: "" });
let initSpread = function(value) {
setSpread(value);
let spreadNS = GC.Spread.Sheets;
let sheet = value.getSheet(0);
sheet.suspendPaint();
let cfs = sheet.conditionalFormats;
// sample title
sheet.addSpan(1, 1, 1, 7);
sheet.setValue(1, 1, "Conditional Format Samples");
sheet.getCell(1, 1).font("24px sans-serif");
sheet.getCell(1, 1).hAlign(spreadNS.HorizontalAlign.center);
sheet.setRowHeight(1, 35);
// cell value rule
let r = 2;
let c = 1;
let w = 3;
let h = 4;
sheet.addSpan(r, c, 1, w);
sheet.setValue(r, c, "Displays green background: value > 50:");
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
let increase = 0;
for (let row = 0; row < h - 1; row++) {
for (let col = 0; col < w; col++) {
sheet.setValue(row + 3, col + 1, increase);
increase += 10;
}
}
sheet.getRange(r, c, h, w).setBorder(new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed), { all: true });
let style = new spreadNS.Style();
style.backColor = "#CCFFCC";
cfs.addCellValueRule(spreadNS.ConditionalFormatting.ComparisonOperators.greaterThan, 50, 0, style, [new spreadNS.Range(r + 1, c, h - 1, w)]);
r = 2;
c = 5;
sheet.addSpan(r, c, 1, w);
sheet.setValue(r, c, "Displays red background: value >= 60 and value <= 70:");
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
increase = 0;
for (let row = 0; row < h - 1; row++) {
for (let col = 0; col < w; col++) {
sheet.setValue(row + r + 1, col + c, increase);
increase += 10;
}
}
sheet.getRange(r, c, h, w).setBorder(new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed), { all: true });
style = new spreadNS.Style();
style.backColor = "#FFCCCC";
cfs.addCellValueRule(spreadNS.ConditionalFormatting.ComparisonOperators.between, 60, 70, style, [new spreadNS.Range(r + 1, c, h - 1, w)]);
// 2 color scale rule
r = 7;
c = 1;
sheet.addSpan(r, c, 1, w);
sheet.setValue(r, c, "Displays two color gradient represents cell value:");
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
increase = 0;
for (let row = 0; row < h - 1; row++) {
for (let col = 0; col < w; col++) {
sheet.setValue(row + r + 1, col + c, increase);
increase += 10;
}
}
sheet.getRange(r, c, h, w).setBorder(new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed), { all: true });
cfs.add2ScaleRule(spreadNS.ConditionalFormatting.ScaleValueType.lowestValue, null, "#FF9999", spreadNS.ConditionalFormatting.ScaleValueType.highestValue, null, "#9999FF", [new spreadNS.Range(r + 1, c, h - 1, w)]);
// 3 color scale rule
r = 7;
c = 5;
sheet.addSpan(r, c, 1, w);
sheet.setValue(r, c, "Displays three color gradient represents cell value:");
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
increase = 0;
for (let row = 0; row < h - 1; row++) {
for (let col = 0; col < w; col++) {
sheet.setValue(row + r + 1, col + c, increase);
increase += 10;
}
}
sheet.getRange(r, c, h, w).setBorder(new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed), { all: true });
cfs.add3ScaleRule(spreadNS.ConditionalFormatting.ScaleValueType.lowestValue, null, "#FF9999",
spreadNS.ConditionalFormatting.ScaleValueType.number, 100, "#99FF99",
spreadNS.ConditionalFormatting.ScaleValueType.highestValue, null, "#9999FF", [new spreadNS.Range(r + 1, c, h - 1, w)]);
r = 12;
c = 1;
sheet.addSpan(r, c, 1, w);
sheet.setValue(r, c, "Display blue background if cell value is in next week:");
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
increase = 0;
for (let row = 0; row < h - 1; row++) {
for (let col = 0; col < w; col++) {
sheet.setValue(row + r + 1, col + c, addDays(new Date(), increase));
sheet.setFormatter(row + r + 1, col + c, "yyyy/mm/dd", spreadNS.SheetArea.viewport);
increase += 1;
}
}
sheet.getRange(r, c, h, w).setBorder(new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed), { all: true });
style = new spreadNS.Style();
style.backColor = "#CCCCFF";
cfs.addDateOccurringRule(spreadNS.ConditionalFormatting.DateOccurringType.nextWeek, style, [new spreadNS.Range(r + 1, c, h - 1, w)]);
// specific text rule
r = 12;
c = 5;
sheet.addSpan(r, c, 1, w);
sheet.setValue(r, c, "Display red foreground if cell value contains \"o\":");
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
let data = ["The", "quick", "brown", "fox", "jumps", "over", "the", "lazy", "dog", "The", "quick", "brown", "fox", "jumps", "over", "the", "lazy", "dog"];
increase = 0;
for (let row = 0; row < h - 1; row++) {
for (let col = 0; col < w; col++) {
sheet.setValue(row + r + 1, col + c, data[increase]);
increase += 1;
}
}
sheet.getRange(r, c, h, w).setBorder(new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed), { all: true });
style = new spreadNS.Style();
style.foreColor = "Red";
style.font = "bold 12px sans-serif";
cfs.addSpecificTextRule(spreadNS.ConditionalFormatting.TextComparisonOperators.contains, "o", style, [new spreadNS.Range(r + 1, c, h - 1, w)]);
// data bar rule
r = 17;
c = 1;
sheet.addSpan(r, c, 1, w);
sheet.setValue(r, c, "Display a colored data bar represents cell value:");
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
increase = 0;
for (let row = 0; row < h - 1; row++) {
for (let col = 0; col < w; col++) {
sheet.setValue(row + r + 1, col + c, increase);
increase += 10;
}
}
sheet.getRange(r, c, h, w).setBorder(new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed), { all: true });
let dataBarRule = cfs.addDataBarRule(spreadNS.ConditionalFormatting.ScaleValueType.lowestValue, null,
spreadNS.ConditionalFormatting.ScaleValueType.highestValue, null,
"green", [new spreadNS.Range(r + 1, c, h - 1, w)]);
dataBarRule.gradient(true);
dataBarRule.showBorder(false);
dataBarRule.showBarOnly(false);
// icon set rule
r = 17;
c = 5;
sheet.addSpan(r, c, 1, w);
sheet.setValue(r, c, "Displays an icon represents cell value:");
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
increase = 0;
for (let row = 0; row < h - 1; row++) {
for (let col = 0; col < w; col++) {
sheet.setValue(row + r + 1, col + c, increase);
increase += 10;
}
}
sheet.getRange(r, c, h, w).setBorder(new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed), { all: true });
let iconSetRule = cfs.addIconSetRule(spreadNS.ConditionalFormatting.IconSetType.fiveArrowsColored, [new spreadNS.Range(r + 1, c, h - 1, w)]);
iconSetRule.iconSetType();
iconSetRule.reverseIconOrder(false);
iconSetRule.showIconOnly(false);
// sparkline rule
r = 22, c = 1;
sheet.addSpan(r, c, 1, 3);
sheet.setValue(r, c, 'Sales Team KPI - Actual vs Target (Bullet Sparkline):');
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
r = 23;
var bulletHeaders = ['Employee', 'Score', 'Performance'];
for (c = 1; c < 4; c++) {
sheet.setValue(r, c, bulletHeaders[c]);
}
var employees = ['Alice', 'Bob', 'Carol', 'David', 'Eva'];
var scores = [88, 72, 95, 58, 81];
for (let i = 0; i < 5; i++) {
sheet.setValue(r + 1 + i, 1, employees[i]);
sheet.setValue(r + 1 + i, 2, scores[i]);
sheet.setValue(r + 1 + i, 3, scores[i]);
sheet.setRowHeight(r + 1 + i, 28);
}
sheet.getRange(r - 1, 1, 7, 3).setBorder(new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed), { all: true });
var rule = cfs.addSparklineRule('BULLETSPARKLINE', {
measure: '@', target: 75, maxi: 100, good: 85, bad: 60, forecast: 80, colorScheme: '#4472C4'
}, [new spreadNS.Range(r + 1, 3, 5, 1)]);
if (rule) rule.showSparklineOnly(true);
r = 22; c = 5;
sheet.addSpan(r, c, 1, 5);
sheet.setValue(r, c, 'Budget Plan vs Actual (Lollipop Variance Sparkline):');
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
r = 23;
var lolHeaders = ['Department', 'Planned', 'Actual', 'Index', 'Variance'];
sheet.setColumnWidth(9, 160);
for (let i = 0; i < 5; i++) {
sheet.setValue(r, c + i, lolHeaders[i]);
}
var depts = ['R&D', 'Marketing', 'Sales', 'Support', 'HR'];
var planned = [500, 300, 400, 200, 150];
let actual = [380, 350, 360, 220, 120];
for (let i = 0; i < 5; i++) {
sheet.setValue(r + 1 + i, c, depts[i]);
sheet.setValue(r + 1 + i, c + 1, planned[i]);
sheet.setValue(r + 1 + i, c + 2, actual[i]);
sheet.setValue(r + 1 + i, c + 3, i + 1);
sheet.setRowHeight(r + 1 + i, 28);
}
sheet.getRange(r - 1, c, 7, 5).setBorder(new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed), { all: true });
// Helper: convert column index to letter (0=A, 1=B, ...)
function colToLetter(col) {
var s = '';
col++;
while (col > 0) {
col--;
s = String.fromCharCode(65 + (col % 26)) + s;
col = Math.floor(col / 26);
}
return s;
}
// Helper: build absolute range string like "$F$5:$K$5"
function absRange(row, col, rowCount, colCount) {
var r1 = row + 1, r2 = row + rowCount;
var c1 = colToLetter(col), c2 = colToLetter(col + colCount - 1);
return '$' + c1 + '$' + r1 + ':$' + c2 + '$' + r2;
}
var plannedRef = absRange(r + 1, c + 1, 5, 1);
var actualRef = absRange(r + 1, c + 2, 5, 1);
var rule = cfs.addSparklineRule('LOLLIPOPVARISPARKLINE', {
plannedValue: plannedRef,
actualValue: actualRef,
index: '@',
reference: 0,
mini: -0.5,
maxi: 0.5,
tickUnit: 0.1,
legend: true,
colorPositive: '#70AD47',
colorNegative: '#ED7D31',
lollipopHeaderColor: '#4472C4'
}, [new spreadNS.Range(r + 1, c + 4, 5, 1)]);
if (rule) rule.showSparklineOnly(true);
sheet.resumePaint();
updateRuleCount(value);
}
// date occurring rule
let addDays = function(date, days) {
let dt = new Date(date.getFullYear(), date.getMonth(), date.getDate() + days);
if (days) {
if (dt.getDate() === date.getDate()) {
dt = new Date(date.getFullYear(), date.getMonth(), date.getDate());
dt.setTime(dt.getTime() + (days * 24 * 3600 * 1000));
}
}
return dt;
}
let removeRule = function() {
let sheet = spread.getSheet(0);
let cfs = sheet.conditionalFormats;
let sels = sheet.getSelections();
if (sels && sels.length > 0) {
let sel = sels[0];
cfs.removeRuleByRange(sel.row, sel.col, sel.rowCount, sel.colCount);
updateRuleCount(spread);
}
}
let clearRule = function() {
let sheet = spread.getSheet(0);
let cfs = sheet.conditionalFormats;
cfs.clearRule();
updateRuleCount(spread);
}
let updateRuleCount = function(spread) {
let sheet = spread.getActiveSheet();
let cfs = sheet.conditionalFormats;
setState({ruleCountDescription: "Rule Count: " + cfs.count()});
}
return (<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
<div className="options-container">
<p>Select cell(s) that contains rule(s):</p>
<div className="option-row">
<input id="ruleCount" style={{ border: 'none' }} value={state.ruleCountDescription} />
</div>
<div className="option-row">
<input type="button" id="removeRule" defaultValue="Remove the selection's rule" onClick={e=>removeRule(e)}/>
<input type="button" id="clearRule" defaultValue="Remove all the rules" onClick={e=>clearRule(e)}/>
</div>
</div>
</div>);
}
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import GC from '@mescius/spread-sheets';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import './styles.css';
const Component = React.Component;
function _getElementById(id) {
return document.getElementById(id);
}
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
this.state = { ruleCountDescription: "" };
}
render() {
return <div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
<div className="options-container">
<p>Select cell(s) that contains rule(s):</p>
<div className="option-row">
<input id="ruleCount" style={{ border: 'none' }} value={this.state.ruleCountDescription} />
</div>
<div className="option-row">
<input type="button" id="removeRule" defaultValue="Remove the selection's rule" onClick={e=>this.removeRule(e)}/>
<input type="button" id="clearRule" defaultValue="Remove all the rules" onClick={e=>this.clearRule(e)}/>
</div>
</div>
</div>;
}
initSpread(spread) {
this.spread = spread;
let spreadNS = GC.Spread.Sheets;
let sheet = spread.getSheet(0);
sheet.suspendPaint();
let cfs = sheet.conditionalFormats;
// sample title
sheet.addSpan(1, 1, 1, 7);
sheet.setValue(1, 1, "Conditional Format Samples");
sheet.getCell(1, 1).font("24px sans-serif");
sheet.getCell(1, 1).hAlign(spreadNS.HorizontalAlign.center);
sheet.setRowHeight(1, 35);
// cell value rule
let r = 2;
let c = 1;
let w = 3;
let h = 4;
sheet.addSpan(r, c, 1, w);
sheet.setValue(r, c, "Displays green background: value > 50:");
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
let increase = 0;
for (let row = 0; row < h - 1; row++) {
for (let col = 0; col < w; col++) {
sheet.setValue(row + 3, col + 1, increase);
increase += 10;
}
}
sheet.getRange(r, c, h, w).setBorder(new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed), { all: true });
let style = new spreadNS.Style();
style.backColor = "#CCFFCC";
cfs.addCellValueRule(spreadNS.ConditionalFormatting.ComparisonOperators.greaterThan, 50, 0, style, [new spreadNS.Range(r + 1, c, h - 1, w)]);
r = 2;
c = 5;
sheet.addSpan(r, c, 1, w);
sheet.setValue(r, c, "Displays red background: value >= 60 and value <= 70:");
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
increase = 0;
for (let row = 0; row < h - 1; row++) {
for (let col = 0; col < w; col++) {
sheet.setValue(row + r + 1, col + c, increase);
increase += 10;
}
}
sheet.getRange(r, c, h, w).setBorder(new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed), { all: true });
style = new spreadNS.Style();
style.backColor = "#FFCCCC";
cfs.addCellValueRule(spreadNS.ConditionalFormatting.ComparisonOperators.between, 60, 70, style, [new spreadNS.Range(r + 1, c, h - 1, w)]);
// 2 color scale rule
r = 7;
c = 1;
sheet.addSpan(r, c, 1, w);
sheet.setValue(r, c, "Displays two color gradient represents cell value:");
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
increase = 0;
for (let row = 0; row < h - 1; row++) {
for (let col = 0; col < w; col++) {
sheet.setValue(row + r + 1, col + c, increase);
increase += 10;
}
}
sheet.getRange(r, c, h, w).setBorder(new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed), { all: true });
cfs.add2ScaleRule(spreadNS.ConditionalFormatting.ScaleValueType.lowestValue, null, "#FF9999", spreadNS.ConditionalFormatting.ScaleValueType.highestValue, null, "#9999FF", [new spreadNS.Range(r + 1, c, h - 1, w)]);
// 3 color scale rule
r = 7;
c = 5;
sheet.addSpan(r, c, 1, w);
sheet.setValue(r, c, "Displays three color gradient represents cell value:");
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
increase = 0;
for (let row = 0; row < h - 1; row++) {
for (let col = 0; col < w; col++) {
sheet.setValue(row + r + 1, col + c, increase);
increase += 10;
}
}
sheet.getRange(r, c, h, w).setBorder(new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed), { all: true });
cfs.add3ScaleRule(spreadNS.ConditionalFormatting.ScaleValueType.lowestValue, null, "#FF9999",
spreadNS.ConditionalFormatting.ScaleValueType.number, 100, "#99FF99",
spreadNS.ConditionalFormatting.ScaleValueType.highestValue, null, "#9999FF", [new spreadNS.Range(r + 1, c, h - 1, w)]);
r = 12;
c = 1;
sheet.addSpan(r, c, 1, w);
sheet.setValue(r, c, "Display blue background if cell value is in next week:");
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
increase = 0;
for (let row = 0; row < h - 1; row++) {
for (let col = 0; col < w; col++) {
sheet.setValue(row + r + 1, col + c, this.addDays(new Date(), increase));
sheet.setFormatter(row + r + 1, col + c, "yyyy/mm/dd", spreadNS.SheetArea.viewport);
increase += 1;
}
}
sheet.getRange(r, c, h, w).setBorder(new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed), { all: true });
style = new spreadNS.Style();
style.backColor = "#CCCCFF";
cfs.addDateOccurringRule(spreadNS.ConditionalFormatting.DateOccurringType.nextWeek, style, [new spreadNS.Range(r + 1, c, h - 1, w)]);
// specific text rule
r = 12;
c = 5;
sheet.addSpan(r, c, 1, w);
sheet.setValue(r, c, "Display red foreground if cell value contains \"o\":");
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
let data = ["The", "quick", "brown", "fox", "jumps", "over", "the", "lazy", "dog", "The", "quick", "brown", "fox", "jumps", "over", "the", "lazy", "dog"];
increase = 0;
for (let row = 0; row < h - 1; row++) {
for (let col = 0; col < w; col++) {
sheet.setValue(row + r + 1, col + c, data[increase]);
increase += 1;
}
}
sheet.getRange(r, c, h, w).setBorder(new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed), { all: true });
style = new spreadNS.Style();
style.foreColor = "Red";
style.font = "bold 12px sans-serif";
cfs.addSpecificTextRule(spreadNS.ConditionalFormatting.TextComparisonOperators.contains, "o", style, [new spreadNS.Range(r + 1, c, h - 1, w)]);
// data bar rule
r = 17;
c = 1;
sheet.addSpan(r, c, 1, w);
sheet.setValue(r, c, "Display a colored data bar represents cell value:");
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
increase = 0;
for (let row = 0; row < h - 1; row++) {
for (let col = 0; col < w; col++) {
sheet.setValue(row + r + 1, col + c, increase);
increase += 10;
}
}
sheet.getRange(r, c, h, w).setBorder(new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed), { all: true });
let dataBarRule = cfs.addDataBarRule(spreadNS.ConditionalFormatting.ScaleValueType.lowestValue, null,
spreadNS.ConditionalFormatting.ScaleValueType.highestValue, null,
"green", [new spreadNS.Range(r + 1, c, h - 1, w)]);
dataBarRule.gradient(true);
dataBarRule.showBorder(false);
dataBarRule.showBarOnly(false);
// icon set rule
r = 17;
c = 5;
sheet.addSpan(r, c, 1, w);
sheet.setValue(r, c, "Displays an icon represents cell value:");
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
increase = 0;
for (let row = 0; row < h - 1; row++) {
for (let col = 0; col < w; col++) {
sheet.setValue(row + r + 1, col + c, increase);
increase += 10;
}
}
sheet.getRange(r, c, h, w).setBorder(new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed), { all: true });
let iconSetRule = cfs.addIconSetRule(spreadNS.ConditionalFormatting.IconSetType.fiveArrowsColored, [new spreadNS.Range(r + 1, c, h - 1, w)]);
iconSetRule.iconSetType();
iconSetRule.reverseIconOrder(false);
iconSetRule.showIconOnly(false);
// sparkline rule
r = 22, c = 1;
sheet.addSpan(r, c, 1, 3);
sheet.setValue(r, c, 'Sales Team KPI - Actual vs Target (Bullet Sparkline):');
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
r = 23;
var bulletHeaders = ['Employee', 'Score', 'Performance'];
for (c = 1; c < 4; c++) {
sheet.setValue(r, c, bulletHeaders[c]);
}
var employees = ['Alice', 'Bob', 'Carol', 'David', 'Eva'];
var scores = [88, 72, 95, 58, 81];
for (let i = 0; i < 5; i++) {
sheet.setValue(r + 1 + i, 1, employees[i]);
sheet.setValue(r + 1 + i, 2, scores[i]);
sheet.setValue(r + 1 + i, 3, scores[i]);
sheet.setRowHeight(r + 1 + i, 28);
}
sheet.getRange(r - 1, 1, 7, 3).setBorder(new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed), { all: true });
var rule = cfs.addSparklineRule('BULLETSPARKLINE', {
measure: '@', target: 75, maxi: 100, good: 85, bad: 60, forecast: 80, colorScheme: '#4472C4'
}, [new spreadNS.Range(r + 1, 3, 5, 1)]);
if (rule) rule.showSparklineOnly(true);
r = 22; c = 5;
sheet.addSpan(r, c, 1, 5);
sheet.setValue(r, c, 'Budget Plan vs Actual (Lollipop Variance Sparkline):');
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
r = 23;
var lolHeaders = ['Department', 'Planned', 'Actual', 'Index', 'Variance'];
sheet.setColumnWidth(9, 160);
for (let i = 0; i < 5; i++) {
sheet.setValue(r, c + i, lolHeaders[i]);
}
var depts = ['R&D', 'Marketing', 'Sales', 'Support', 'HR'];
var planned = [500, 300, 400, 200, 150];
let actual = [380, 350, 360, 220, 120];
for (let i = 0; i < 5; i++) {
sheet.setValue(r + 1 + i, c, depts[i]);
sheet.setValue(r + 1 + i, c + 1, planned[i]);
sheet.setValue(r + 1 + i, c + 2, actual[i]);
sheet.setValue(r + 1 + i, c + 3, i + 1);
sheet.setRowHeight(r + 1 + i, 28);
}
sheet.getRange(r - 1, c, 7, 5).setBorder(new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed), { all: true });
// Helper: convert column index to letter (0=A, 1=B, ...)
function colToLetter(col) {
var s = '';
col++;
while (col > 0) {
col--;
s = String.fromCharCode(65 + (col % 26)) + s;
col = Math.floor(col / 26);
}
return s;
}
// Helper: build absolute range string like "$F$5:$K$5"
function absRange(row, col, rowCount, colCount) {
var r1 = row + 1, r2 = row + rowCount;
var c1 = colToLetter(col), c2 = colToLetter(col + colCount - 1);
return '$' + c1 + '$' + r1 + ':$' + c2 + '$' + r2;
}
var plannedRef = absRange(r + 1, c + 1, 5, 1);
var actualRef = absRange(r + 1, c + 2, 5, 1);
var rule = cfs.addSparklineRule('LOLLIPOPVARISPARKLINE', {
plannedValue: plannedRef,
actualValue: actualRef,
index: '@',
reference: 0,
mini: -0.5,
maxi: 0.5,
tickUnit: 0.1,
legend: true,
colorPositive: '#70AD47',
colorNegative: '#ED7D31',
lollipopHeaderColor: '#4472C4'
}, [new spreadNS.Range(r + 1, c + 4, 5, 1)]);
if (rule) rule.showSparklineOnly(true);
sheet.resumePaint();
this.updateRuleCount();
}
// date occurring rule
addDays(date, days) {
let dt = new Date(date.getFullYear(), date.getMonth(), date.getDate() + days);
if (days) {
if (dt.getDate() === date.getDate()) {
dt = new Date(date.getFullYear(), date.getMonth(), date.getDate());
dt.setTime(dt.getTime() + (days * 24 * 3600 * 1000));
}
}
return dt;
}
removeRule() {
let sheet = this.spread.getSheet(0);
let cfs = sheet.conditionalFormats;
let sels = sheet.getSelections();
if (sels && sels.length > 0) {
let sel = sels[0];
cfs.removeRuleByRange(sel.row, sel.col, sel.rowCount, sel.colCount);
this.updateRuleCount();
}
}
clearRule() {
let sheet = this.spread.getSheet(0);
let cfs = sheet.conditionalFormats;
cfs.clearRule();
this.updateRuleCount();
}
updateRuleCount() {
let sheet = this.spread.getSheet(0);
let cfs = sheet.conditionalFormats;
this.setState({ruleCountDescription: "Rule Count: " + cfs.count()});
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
overflow: auto;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
}
.option-row {
padding-top: 6px;
}
input {
padding: 4px 8px;
margin-bottom: 6px;
box-sizing: border-box;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.1.2-master-2026-06-10-2131/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-react': 'cdn:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/cjs/react.production.js',
'react-dom': 'npm:react-dom/cjs/react-dom.production.js',
'react-dom/client': 'npm:react-dom/cjs/react-dom-client.production.js',
'scheduler': 'npm:scheduler/cjs/scheduler.production.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

To add conditional formatting in SpreadJS, first use the conditionalFormats method to get the conditional format for the sheet. Then you can create a conditional rule and use the addRule method to add it. Also you can use the specified rule's add method, like addSpecificTextRule, addCellValueRule, and so on. For example:
After you add rules to the sheet, you can use the getRule method to return the rule using the rule index or get all the conditional rules. For example:
If you want to remove the conditional rule, use the removeRule, removeRuleByRange, or clearRule methods. For example:
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbook-initialized="initSpread">
<gc-worksheet></gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<p>Select cell(s) that contains rule(s):</p>
<div class="option-row">
<input id="ruleCount" style="border: none;" :value="ruleCountDescription" />
</div>
<div class="option-row">
<input type="button" id="removeRule" value="Remove the selection's rule" @click="removeRule" />
<input type="button" id="clearRule" value="Remove all the rules" @click="clearRule" />
</div>
</div>
</div>
</template>
<script setup>
import { ref } from 'vue';
import '@mescius/spread-sheets-vue';
import GC from '@mescius/spread-sheets';
const spread = ref(null);
const ruleCountDescription = ref('');
const initSpread = (spreadInstance) => {
spread.value = spreadInstance;
const spreadNS = GC.Spread.Sheets;
const sheet = spreadInstance.getSheet(0);
sheet.suspendPaint();
const cfs = sheet.conditionalFormats;
// sample title
sheet.addSpan(1, 1, 1, 7);
sheet.setValue(1, 1, "Conditional Format Samples");
sheet.getCell(1, 1).font("24px sans-serif");
sheet.getCell(1, 1).hAlign(spreadNS.HorizontalAlign.center);
sheet.setRowHeight(1, 35);
// cell value rule
let r = 2;
let c = 1;
let w = 3;
let h = 4;
sheet.addSpan(r, c, 1, w);
sheet.setValue(r, c, "Displays green background: value > 50:");
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
let increase = 0;
for (let row = 0; row < h - 1; row++) {
for (let col = 0; col < w; col++) {
sheet.setValue(row + 3, col + 1, increase);
increase += 10;
}
}
sheet.getRange(r, c, h, w).setBorder(
new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed),
{ all: true }
);
let style = new spreadNS.Style();
style.backColor = "#CCFFCC";
cfs.addCellValueRule(
spreadNS.ConditionalFormatting.ComparisonOperators.greaterThan,
50,
0,
style,
[new spreadNS.Range(r + 1, c, h - 1, w)]
);
r = 2;
c = 5;
sheet.addSpan(r, c, 1, w);
sheet.setValue(r, c, "Displays red background: value >= 60 and value <= 70:");
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
increase = 0;
for (let row = 0; row < h - 1; row++) {
for (let col = 0; col < w; col++) {
sheet.setValue(row + r + 1, col + c, increase);
increase += 10;
}
}
sheet.getRange(r, c, h, w).setBorder(
new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed),
{ all: true }
);
style = new spreadNS.Style();
style.backColor = "#FFCCCC";
cfs.addCellValueRule(
spreadNS.ConditionalFormatting.ComparisonOperators.between,
60,
70,
style,
[new spreadNS.Range(r + 1, c, h - 1, w)]
);
// 2 color scale rule
r = 7;
c = 1;
sheet.addSpan(r, c, 1, w);
sheet.setValue(r, c, "Displays two color gradient represents cell value:");
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
increase = 0;
for (let row = 0; row < h - 1; row++) {
for (let col = 0; col < w; col++) {
sheet.setValue(row + r + 1, col + c, increase);
increase += 10;
}
}
sheet.getRange(r, c, h, w).setBorder(
new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed),
{ all: true }
);
cfs.add2ScaleRule(
spreadNS.ConditionalFormatting.ScaleValueType.lowestValue,
null,
"#FF9999",
spreadNS.ConditionalFormatting.ScaleValueType.highestValue,
null,
"#9999FF",
[new spreadNS.Range(r + 1, c, h - 1, w)]
);
// 3 color scale rule
r = 7;
c = 5;
sheet.addSpan(r, c, 1, w);
sheet.setValue(r, c, "Displays three color gradient represents cell value:");
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
increase = 0;
for (let row = 0; row < h - 1; row++) {
for (let col = 0; col < w; col++) {
sheet.setValue(row + r + 1, col + c, increase);
increase += 10;
}
}
sheet.getRange(r, c, h, w).setBorder(
new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed),
{ all: true }
);
cfs.add3ScaleRule(
spreadNS.ConditionalFormatting.ScaleValueType.lowestValue,
null,
"#FF9999",
spreadNS.ConditionalFormatting.ScaleValueType.number,
100,
"#99FF99",
spreadNS.ConditionalFormatting.ScaleValueType.highestValue,
null,
"#9999FF",
[new spreadNS.Range(r + 1, c, h - 1, w)]
);
r = 12;
c = 1;
sheet.addSpan(r, c, 1, w);
sheet.setValue(r, c, "Display blue background if cell value is in next week:");
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
increase = 0;
for (let row = 0; row < h - 1; row++) {
for (let col = 0; col < w; col++) {
sheet.setValue(row + r + 1, col + c, addDays(new Date(), increase));
sheet.setFormatter(row + r + 1, col + c, "yyyy/mm/dd", spreadNS.SheetArea.viewport);
increase += 1;
}
}
sheet.getRange(r, c, h, w).setBorder(
new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed),
{ all: true }
);
style = new spreadNS.Style();
style.backColor = "#CCCCFF";
cfs.addDateOccurringRule(
spreadNS.ConditionalFormatting.DateOccurringType.nextWeek,
style,
[new spreadNS.Range(r + 1, c, h - 1, w)]
);
// specific text rule
r = 12;
c = 5;
sheet.addSpan(r, c, 1, w);
sheet.setValue(r, c, 'Display red foreground if cell value contains "o":');
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
let data = [
"The", "quick", "brown", "fox", "jumps", "over", "the", "lazy", "dog",
"The", "quick", "brown", "fox", "jumps", "over", "the", "lazy", "dog"
];
increase = 0;
for (let row = 0; row < h - 1; row++) {
for (let col = 0; col < w; col++) {
sheet.setValue(row + r + 1, col + c, data[increase]);
increase += 1;
}
}
sheet.getRange(r, c, h, w).setBorder(
new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed),
{ all: true }
);
style = new spreadNS.Style();
style.foreColor = "Red";
style.font = "bold 12px sans-serif";
cfs.addSpecificTextRule(
spreadNS.ConditionalFormatting.TextComparisonOperators.contains,
"o",
style,
[new spreadNS.Range(r + 1, c, h - 1, w)]
);
// data bar rule
r = 17;
c = 1;
sheet.addSpan(r, c, 1, w);
sheet.setValue(r, c, "Display a colored data bar represents cell value:");
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
increase = 0;
for (let row = 0; row < h - 1; row++) {
for (let col = 0; col < w; col++) {
sheet.setValue(row + r + 1, col + c, increase);
increase += 10;
}
}
sheet.getRange(r, c, h, w).setBorder(
new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed),
{ all: true }
);
let dataBarRule = cfs.addDataBarRule(
spreadNS.ConditionalFormatting.ScaleValueType.lowestValue,
null,
spreadNS.ConditionalFormatting.ScaleValueType.highestValue,
null,
"green",
[new spreadNS.Range(r + 1, c, h - 1, w)]
);
dataBarRule.gradient(true);
dataBarRule.showBorder(false);
dataBarRule.showBarOnly(false);
// icon set rule
r = 17;
c = 5;
sheet.addSpan(r, c, 1, w);
sheet.setValue(r, c, "Displays an icon represents cell value:");
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
increase = 0;
for (let row = 0; row < h - 1; row++) {
for (let col = 0; col < w; col++) {
sheet.setValue(row + r + 1, col + c, increase);
increase += 10;
}
}
sheet.getRange(r, c, h, w).setBorder(
new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed),
{ all: true }
);
let iconSetRule = cfs.addIconSetRule(
spreadNS.ConditionalFormatting.IconSetType.fiveArrowsColored,
[new spreadNS.Range(r + 1, c, h - 1, w)]
);
iconSetRule.iconSetType();
iconSetRule.reverseIconOrder(false);
iconSetRule.showIconOnly(false);
// sparkline rule
r = 22, c = 1;
sheet.addSpan(r, c, 1, 3);
sheet.setValue(r, c, 'Sales Team KPI - Actual vs Target (Bullet Sparkline):');
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
r = 23;
var bulletHeaders = ['Employee', 'Score', 'Performance'];
for (c = 1; c < 4; c++) {
sheet.setValue(r, c, bulletHeaders[c]);
}
var employees = ['Alice', 'Bob', 'Carol', 'David', 'Eva'];
var scores = [88, 72, 95, 58, 81];
for (let i = 0; i < 5; i++) {
sheet.setValue(r + 1 + i, 1, employees[i]);
sheet.setValue(r + 1 + i, 2, scores[i]);
sheet.setValue(r + 1 + i, 3, scores[i]);
sheet.setRowHeight(r + 1 + i, 28);
}
sheet.getRange(r - 1, 1, 7, 3).setBorder(new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed), { all: true });
var rule = cfs.addSparklineRule('BULLETSPARKLINE', {
measure: '@', target: 75, maxi: 100, good: 85, bad: 60, forecast: 80, colorScheme: '#4472C4'
}, [new spreadNS.Range(r + 1, 3, 5, 1)]);
if (rule) rule.showSparklineOnly(true);
r = 22; c = 5;
sheet.addSpan(r, c, 1, 5);
sheet.setValue(r, c, 'Budget Plan vs Actual (Lollipop Variance Sparkline):');
sheet.getCell(r, c).wordWrap(true);
sheet.setRowHeight(r, 40);
r = 23;
var lolHeaders = ['Department', 'Planned', 'Actual', 'Index', 'Variance'];
sheet.setColumnWidth(9, 160);
for (let i = 0; i < 5; i++) {
sheet.setValue(r, c + i, lolHeaders[i]);
}
var depts = ['R&D', 'Marketing', 'Sales', 'Support', 'HR'];
var planned = [500, 300, 400, 200, 150];
let actual = [380, 350, 360, 220, 120];
for (let i = 0; i < 5; i++) {
sheet.setValue(r + 1 + i, c, depts[i]);
sheet.setValue(r + 1 + i, c + 1, planned[i]);
sheet.setValue(r + 1 + i, c + 2, actual[i]);
sheet.setValue(r + 1 + i, c + 3, i + 1);
sheet.setRowHeight(r + 1 + i, 28);
}
sheet.getRange(r - 1, c, 7, 5).setBorder(new spreadNS.LineBorder("Black", spreadNS.LineStyle.dashed), { all: true });
// Helper: convert column index to letter (0=A, 1=B, ...)
function colToLetter(col) {
var s = '';
col++;
while (col > 0) {
col--;
s = String.fromCharCode(65 + (col % 26)) + s;
col = Math.floor(col / 26);
}
return s;
}
// Helper: build absolute range string like "$F$5:$K$5"
function absRange(row, col, rowCount, colCount) {
var r1 = row + 1, r2 = row + rowCount;
var c1 = colToLetter(col), c2 = colToLetter(col + colCount - 1);
return '$' + c1 + '$' + r1 + ':$' + c2 + '$' + r2;
}
var plannedRef = absRange(r + 1, c + 1, 5, 1);
var actualRef = absRange(r + 1, c + 2, 5, 1);
var rule = cfs.addSparklineRule('LOLLIPOPVARISPARKLINE', {
plannedValue: plannedRef,
actualValue: actualRef,
index: '@',
reference: 0,
mini: -0.5,
maxi: 0.5,
tickUnit: 0.1,
legend: true,
colorPositive: '#70AD47',
colorNegative: '#ED7D31',
lollipopHeaderColor: '#4472C4'
}, [new spreadNS.Range(r + 1, c + 4, 5, 1)]);
if (rule) rule.showSparklineOnly(true);
sheet.resumePaint();
updateRuleCount();
};
const addDays = (date, days) => {
let dt = new Date(date.getFullYear(), date.getMonth(), date.getDate() + days);
if (days) {
if (dt.getDate() === date.getDate()) {
dt = new Date(date.getFullYear(), date.getMonth(), date.getDate());
dt.setTime(dt.getTime() + days * 24 * 3600 * 1000);
}
}
return dt;
};
const removeRule = () => {
const sheet = spread.value.getSheet(0);
const cfs = sheet.conditionalFormats;
const sels = sheet.getSelections();
if (sels && sels.length > 0) {
const sel = sels[0];
cfs.removeRuleByRange(sel.row, sel.col, sel.rowCount, sel.colCount);
updateRuleCount();
}
};
const clearRule = () => {
const sheet = spread.value.getSheet(0);
const cfs = sheet.conditionalFormats;
cfs.clearRule();
updateRuleCount();
};
const updateRuleCount = () => {
const sheet = spread.value.getSheet(0);
const cfs = sheet.conditionalFormats;
ruleCountDescription.value = "Rule Count: " + cfs.count();
};
</script>
<style scoped>
#app {
height: 100%;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
overflow: auto;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
}
.option-row {
padding-top: 6px;
}
input {
padding: 4px 8px;
margin-bottom: 6px;
box-sizing: border-box;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script src="compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.1.2-master-2026-06-10-2131/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-vue': 'cdn:@mescius/spread-sheets-vue/index.js',
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);